#!/usr/bin/env python

# -*- coding: utf-8 -*-

#

# Make stars look bigger in starry night photos
#
#


import sys, os, numpy
from PIL import Image

if __name__ == '__main__':
	if len(sys.argv) < 3:
		print
		print "Usage: %s <image name> <magnification factor>" % sys.argv[0]
		sys.exit(1)
	else:
		try:
			im = Image.open(sys.argv[1])
			rad = float(sys.argv[2])
		except:
			raise
		# get pixels
		pa = im.load()
		w, h = im.size
		# create bufferof the size of the image
		buf = numpy.zeros((w, h, 3), 'i')
		# blow up
		for y in range(h):
			print "%d of %d" % (y, h)
			for x in range(w):
				rgb = pa[x,y]
				# if pixel too dark, skip
				if rgb[0] + rgb[1] + rgb[2] < 10:
					continue
				# add intrinsic pixel value to buf
				for z in range(3):
					buf[x,y,z] += rgb[z]
				for j in range(max(0, y-rad), min(h, y+rad)):
					for i in range (max(0, x-rad), min(w, x+rad)):
						# get fade quotient
						dist = float((x - i) * (x - i) + (y - j) * (y - j))
						q = (rad - dist) / rad
						if q > 0:
							for z in range(3):
								buf[i,j,z] += q * rgb[z]
		# copy back to image
		for y in range(h):
			for x in range(w):
				pa[x,y] = (buf[x,y,0],buf[x,y,1],buf[x,y,2])
		# save
		path, ext = os.path.splitext(sys.argv[1])
		im.save(path + '-enh' + str(int(rad)) + ext)
		
		
